'chaser5
'with optional sound input on analogue AN0
'if input IN1 is low, speed varies automatically
'if input IN1 is high, speed depends on sound input
'quiet sounds = slow, loud sounds = fast
'designed for 6 lights

'b5 = non-sound input speed ie auto speed
'b8 = final speed
'initial speed is 0 (ie 256)

start:

	let b5 = b5 - 40	'speed up display by 40
	for b3 = 1 to 5		'start of outer loop
	let b1 = 1		'reset b1

	
	for b0 = 1 to 5		'start of first inner loop
	readadc 0, b7		'read sound level

	let b8 = b7 + b7	'double analogue reading
	let b8 = 200 - b8	'make b8 lower if sound level higher
	
	if pin1 = 1 then skip	'skip next line if IN1 is high
	let b8 = b5		'set final speed to auto speed
	let b7 = 20		'ensures lights do not auto shut-off
	
skip:	let b1 = b1 * 2		'make b1 rise, 2,4,8,16,32 per inner loop
	let b9 = b1 * b3	'make b9 rise, per outer loop
	if b7<10 then none	'lights auto shut-off if no sound

	if b3 = 2 then invert	'add variety by inverting lights	
	if b3 = 5 then invert	'add variety by inverting lights
	goto norm

invert:
	let b9 = 63 - b9	'provide inverse display
	

norm:	
	if b9 > 64 then jump	'prevents chasing too far
	let pins = b9		'switch on lights

	pause b8		'pause lights
jump:	next b0			'end of first inner loop
	
	let b1 = 32		'start of count down
	for b0 = 1 to 5		'start of new inner loop
	let b1 = b1 / 2		'make b1 fall, 16,8,4,2,1
	let b9 = b1 * b3	'make b9 rise per outer loop
	if b3 = 2 then invert2	'add variety by inverting lights
	if b3 = 5 then invert2	'add variety by inverting lights
	goto norm2

invert2:
	let b9 = 63 - b9	'provide inverse display

norm2:
	let pins = b9		'switch on lights
	pause b8		'pause lights
	next b0			'end second inner loop
	next b3			'end outer loop
	goto start
none:
	let pins = 0
	goto start







